/* 
   06/02/2010: modalità 16
   13/01/2010: cambiano i pezzi e il "mobiletto"
   13/12/2009: riordino del cedice
               se il gioco è risolto si ferma per 2 secondi e poi aspetta il clic del mouse
*/

final int    INIZIALE=  0,  
             GIOCO   =  1,
             FINITO  =  2;            
final int    SHUFFLE =300;  // numero di tentativi per mescolare i pezzi         
final String MODI[]   = {"15", "14", "16", "pal"};
final int    mod15   = 0,      
             mod14   = 1,
             mod16   = 2,
             modPAL  = 3;
final int    nRighe  =  4, 
             nColonne=  4,
             nULTIMA =nRighe*nColonne;
final int    dimR    = 42, 
             dimC    = 42;
final int    baseR   =  18, 
             baseC   =  18;
     
int    stato   = INIZIALE;
int    MODO    = mod15;

int    RIGA[],      
       COLONNA[],
       ultimaR,
       ultimaC;        

PImage SFONDO;
String immagini;
PImage IMMAGINI[];
Blocco BLOCCHI[][];

void setup()
{
    size(204,204);
    
    RIGA    =new int[nRighe];              for(int r=0; r<nRighe;   r++) 
                                                RIGA[r]    =r*dimR+baseR;
    COLONNA =new int[nColonne];            for(int c=0; c<nColonne; c++) 
                                                COLONNA[c] =c*dimC+baseC;
    BLOCCHI    =new Blocco[nRighe][nColonne];

    String modo = param("mode");        
    if(modo != null)
    {
      for(int i=0; i < MODI.length; i++)
        if(modo.equals(MODI[i]))  
        {  
            MODO=i;  
            break;
        }
    }
    switch(MODO)
    {
      case mod15 : immagini="serie1";  
                   IMMAGINI=new PImage[nRighe*nColonne];   
                   for(int i=1; i < nRighe*nColonne; i++)
                       IMMAGINI[i]=loadImage(immagini+"/"+i+".gif");  
                   break;
      case mod14 : immagini="serie1";  
                   IMMAGINI=new PImage[nRighe*nColonne];   
                   for(int i=1; i < nRighe*nColonne; i++)
                       IMMAGINI[i]=loadImage(immagini+"/"+i+".gif");  
                   break;
      case mod16 : immagini="serie1";  
                   IMMAGINI=new PImage[nRighe*nColonne+1];   
                   for(int i=1; i <= nRighe*nColonne; i++)
                       IMMAGINI[i]=loadImage(immagini+"/"+i+".gif");  
                   break;
      case modPAL: immagini="serie5"; 
                   IMMAGINI=new PImage[27];   
                   for(int i=1; i <= 26; i++)
                   {
                       char car=char(byte('a')+i-1);
                       IMMAGINI[i]=loadImage(immagini+"/"+car+".gif");  
                   }
                   break;
    }    
    SFONDO=loadImage(immagini+"/box.gif");
    
    int r, 
        c;    
    switch(MODO)
    {
      case mod15 : r=0;
                   c=0;
                   for(int i=1; i<nULTIMA;  i++)
                   {
                       BLOCCHI[r][c]=new Blocco(r, c, i);
                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }                                         
                   }                   
                   ultimaR=nRighe-1;
                   ultimaC=nColonne-1;
                   BLOCCHI[ultimaR][ultimaC]=new Blocco(ultimaR, ultimaC, 0);  
                   break;
      case mod14 : BLOCCHI[0][0]=new Blocco(0, 0, 0);  
                   r=0;
                   c=1;
                   for(int i=1; i<nULTIMA;  i++)
                   {
                       BLOCCHI[r][c]=new Blocco(r, c, i);
                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }                                         
                   }                   
                   ultimaR=0;
                   ultimaC=0;
                   break;
      case mod16 : r=0;
                   c=0;
                   for(int i=1; i<=nULTIMA;  i++)
                   {
                       BLOCCHI[r][c]=new Blocco(r, c, i);
                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }                                         
                   }                   
                   break;
      case modPAL: String soluzione="RATEYOURMINDPAL";
                   r=0;
                   c=0;
                   for(int i=0; i<soluzione.length();  i++)
                   {
                       char car=soluzione.charAt(i);
                       int  x  =byte(car)-byte('A')+1;
                       BLOCCHI[r][c]=new Blocco(r, c, x, car);  
                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }                                         
                   }                        
                   ultimaR=nRighe-1;
                   ultimaC=nColonne-1;
                   BLOCCHI[ultimaR][ultimaC]=new Blocco(ultimaR, ultimaC, 0, ' ');  
                   break;
    }  
    noLoop();
}

void draw()
{
    background(SFONDO);
    for(int r=0; r<nRighe;   r++)
    for(int c=0; c<nColonne; c++)
        BLOCCHI[r][c].draw();

}

void controlla()
{
    int r=0,
        c=0;
    switch(MODO)
    {
      case mod15 : for(int i=1; i<nULTIMA;  i++)
                   {
                       if(BLOCCHI[r][c].valore != i)  
                           return;

                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }
                   } 
                   finisci();
                   break;
      case mod14 : for(int i=0; i<nULTIMA;  i++)
                   {
                       if(BLOCCHI[r][c].valore != i) 
                           return;

                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }
                   } 
                   finisci();
                   break;
      case mod16 : for(int i=1; i<=nULTIMA;  i++)
                   {
                       if(BLOCCHI[r][c].valore !=0 && BLOCCHI[r][c].valore != i)  
                           return;

                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }
                   } 
                   finisci();
                   break;

      case modPAL: String soluzione="RATEYOURMINDPAL";                   
                   for(int i=0; i<soluzione.length();  i++)
                   {
                       if(BLOCCHI[r][c].carattere != soluzione.charAt(i))
                           return;

                       c++;
                       if(c==nColonne)
                       {
                           r++;
                           c=0;
                       }
                   }
                   finisci();
                   break;
    }
}

void finisci()
{
    stato=FINITO;
    BLOCCHI[ultimaR][ultimaC]=new Blocco(ultimaR, ultimaC, ultimaR*nColonne+ultimaC+1);
    redraw();
    delay(2000);         // rendere più visibile che è finito
    stato=INIZIALE;
    redraw(); 
}

void sposta(int nr, int nc)
{
    if
    (  
       nr == ultimaR && nc == ultimaC-1 && nc >= 0       ||
       nr == ultimaR && nc == ultimaC+1 && nc < nColonne ||
       nc == ultimaC && nr == ultimaR-1 && nr >= 0       ||
       nc == ultimaC && nr == ultimaR+1 && nr < nRighe   )
    {
       // scambia il valore dei blocchi adiacenti
       //      (nr, nc)
       // e 
       //      (ultimaR, ultimaC)
       int  x   = BLOCCHI[nr     ][nc     ].valore;
       char car = BLOCCHI[nr     ][nc     ].carattere;
                  BLOCCHI[nr     ][nc     ].valore   =0;                  
                  BLOCCHI[nr     ][nc     ].carattere=' ';
                  BLOCCHI[ultimaR][ultimaC].valore   =x;
                  BLOCCHI[ultimaR][ultimaC].carattere=car;
       ultimaR=nr;
       ultimaC=nc;
       redraw();                                  // da sistemare...
       if(stato==GIOCO)
           controlla();
    }
}

void mescola()
{
    if(MODO == mod16)
    {
      ultimaR=(int)random(nRighe);
      ultimaC=(int)random(nColonne);
      BLOCCHI[ultimaR][ultimaC]=new Blocco(ultimaR, ultimaC, 0);  
    }  
  
    for(int i=1; i<=SHUFFLE; i++)                // più veloce???
    {
       switch(int(random(4)))
       {
          case 0: sposta(ultimaR+1, ultimaC  ); break;
          case 1: sposta(ultimaR-1, ultimaC  ); break;
          case 2: sposta(ultimaR  , ultimaC+1); break;
          case 3: sposta(ultimaR  , ultimaC-1); break;
       }
    }
}

void mousePressed()
{
    switch(stato)
    {
        case INIZIALE: mescola();
                       stato=GIOCO;
                       break;
        case GIOCO   : int y=mouseY;  int riga   =(y-baseR)/dimR;   
                       int x=mouseX;  int colonna=(x-baseC)/dimC;                      
                       sposta(riga, colonna);        
                       break;
    }   
}

void keyPressed()
{
    switch(stato)
    {
       case INIZIALE: break;
       case GIOCO:    if(key==CODED)
                      {
                         int tasto=keyCode;
                         switch(tasto)
                         {
                            case UP:    sposta(ultimaR+1, ultimaC  ); break;
                            case DOWN:  sposta(ultimaR-1, ultimaC  ); break;
                            case LEFT:  sposta(ultimaR  , ultimaC+1); break;
                            case RIGHT: sposta(ultimaR  , ultimaC-1); break;
                         }
                      }
                      else
                      {
                         int tasto=key;
                         switch(tasto)
                         {
                         }
                      }
                      break;
    }   
}

class Blocco
{
    int  riga;
    int  colonna; 
    int  valore;
    char carattere;

    Blocco(int r, int c, int x)
    {
      riga=r;
      colonna=c;
      valore=x;
    }
    Blocco(int r, int c, int x, char car)
    {
      riga=r;
      colonna=c;
      valore=x;
      carattere=car;
    }
    
    void draw()
    {
        if(valore != 0)  // ....
            image(IMMAGINI[valore], COLONNA[colonna], RIGA[riga]);
    }
}
